Table crashes;
float rectX, rectY;      // Position of square button
int circleX, circleY;
float circleSize; 
float rectSizeX = 130;     // Diameter of rect
float rectSizeY = 50;
color rectColor, baseColor;
color rectHighlight;
color currentColor;
boolean rectClearOver = false;
boolean rectHazeOver = false;
boolean rectRainOver = false;
boolean rectWindOver = false;
boolean rectSleetOver = false;
boolean rectSnowOver = false;
boolean rectUnknownWOver = false;
boolean rectDarkOver = false;
boolean rectDawnOver = false;
boolean rectDayOver = false;
boolean rectDuskOver = false;
boolean rectUnknownLOver = false;
boolean rectDryOver = false;
boolean rectIcyOver = false;
boolean rectSnowyOver = false;
boolean rectWetOver = false;
boolean rectUnknownSOver = false;


int crashAmount; 
  float ring;
  float radius;
  float area;
  float newRadius1;
  float newArea1;
  float newDiameter1;
  float newRadius2;
  float newArea2;
  float newDiameter2;
  float newArea3;
  float newRadius3;
  float newDiameter3;

void setup() {
  size(1400, 800);
  rectColor = color(130,200,220);
  rectHighlight = color(51);  
  baseColor = color(255);
  currentColor = baseColor;
  circleX = 1400/3;
  circleY = 800/2;
  rectX = 1400*.87;
  rectY = 800*.1;
  ellipseMode(CENTER);
  noStroke();
   
  circleSize = 0;

  
}

void draw() {
  

  ring = 900/1.25;
  radius = ring/2;
  area = radius*radius*3.14;
  newArea1 = area*.609;
  newRadius1 = sqrt(newArea1/3.14);
  newDiameter1 = newRadius1*2;
  newArea2 = area*.203;
  newRadius2 = sqrt(newArea2/3.14);
  newDiameter2 = newRadius2*2;
  newArea3 = area*.0105;
  newRadius3 = sqrt(newArea3/3.14);
  newDiameter3 = newRadius3*2;
  
  
  update(mouseX, mouseY);
  background(200);
  
  pushStyle();
  rectMode(RIGHT);
  fill(255);
  stroke(200);
  strokeWeight(20);
  rect(1400-10, 0+10, 1400-535, height-10);
  popStyle();
  
  pushStyle();
  fill(0,60,140);
  ellipse(circleX, circleY, ring, ring);  //4929 crashes
  popStyle();
  pushStyle();
  fill(0,55,130);
  ellipse(circleX, circleY, newDiameter1, newDiameter1);  //3000 crashes
  popStyle();
  pushStyle();
  fill(0,50,120);
  ellipse(circleX, circleY, newDiameter2, newDiameter2); //1000 crashes
  popStyle();
  pushStyle();
  fill(0,45,110);
  ellipse(circleX, circleY, newDiameter3, newDiameter3); //50 crashes
  popStyle();
  pushStyle();
  fill(255, 70, 70, 95);
  stroke(255,255,255, 95);
  strokeWeight(15);
  ellipse(circleX, circleY, circleSize, circleSize);
  popStyle();
  
  pushStyle();
  fill(0, 88, 180);
  textSize(18);
  text("4929 total crashes", circleX, height/50*49-7);
  popStyle();
  
  pushStyle();
  fill(255);
  textSize(18);
  text("3000 crashes", circleX, height/50*43+5);
  text("1000 crashes", circleX, height/50*36);
  text("50 crashes", circleX, height/50*27+15);
  popStyle();
  
  
  
  
//TITLE
  textSize(24);
  text("Chicago Bike Crashes", rectX-rectSizeX*2.4, rectY+rectSizeY*11-30);
  text("2007-2009", rectX-rectSizeX*2.4, rectY+rectSizeY*12-30);
  fill(0, 88, 200);
  


  //WEATHER CONDITIONS

  textSize(24);
  text("weather", rectX, rectY-25);
  fill(0, 88, 200);
  
  
  pushStyle();
  //weather clear
  if (rectClearOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY, rectSizeX, rectSizeY);
  
  //weather haze
  if(rectHazeOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*2, rectSizeX, rectSizeY);
  
  
  //weather wind
   if(rectWindOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*4, rectSizeX, rectSizeY);
  
  //weather rain
   if(rectRainOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*6, rectSizeX, rectSizeY);
  
  //weather sleet
   if(rectSleetOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*8, rectSizeX, rectSizeY);
  
  //weather snow
   if(rectSnowOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*10, rectSizeX, rectSizeY);
  
  //weather unknown
   if(rectUnknownWOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX, rectY+rectSizeY*12, rectSizeX, rectSizeY);
  
  popStyle();
  
  
  
  //LIGHT CONDITIONS

  textSize(24);
  text("light", rectX-rectSizeX*1.2, rectY-25);
  fill(0, 88, 200);

  
    pushStyle();
    //Darkness
  if (rectDarkOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*1.2, rectY, rectSizeX, rectSizeY);
  
  //Daylight
  if(rectDayOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*1.2, rectY+rectSizeY*2, rectSizeX, rectSizeY);
  
  //Dawn
   if(rectDawnOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*1.2, rectY+rectSizeY*4, rectSizeX, rectSizeY);
  
  //Dusk
   if(rectDuskOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*1.2, rectY+rectSizeY*6, rectSizeX, rectSizeY);
  
  //Unknown Light
   if(rectUnknownLOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*1.2, rectY+rectSizeY*8, rectSizeX, rectSizeY);
  popStyle();



//SURFACE CONDITIONS
  
  textSize(24);
  text("surface", rectX-rectSizeX*2.4, rectY-25);
  fill(0, 88, 200);
  
  pushStyle();
    //Dry
  if (rectDryOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*2.4, rectY, rectSizeX, rectSizeY);
  
  //Icy
  if(rectIcyOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*2.4, rectY+rectSizeY*2, rectSizeX, rectSizeY);
  
  //Snow/Slush
   if(rectSnowyOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*2.4, rectY+rectSizeY*4, rectSizeX, rectSizeY);
  
  //Wet
   if(rectWetOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*2.4, rectY+rectSizeY*6, rectSizeX, rectSizeY);
  
  //Unknown Surface
   if(rectUnknownSOver) {
    fill(rectHighlight);
  } else {
    fill(rectColor);
  }
  rect(rectX-rectSizeX*2.4, rectY+rectSizeY*8, rectSizeX, rectSizeY);
  
  popStyle();
  
  
  //BUTTON TEXT

pushStyle();
  fill(255);
  textSize(24);
  textAlign(LEFT, TOP);
  text("DRY", rectX-rectSizeX*2.4+4, rectY+10);
  text("ICY", rectX-rectSizeX*2.4+4, rectY+rectSizeY*2+10);
  text("SNOWED", rectX-rectSizeX*2.4+4, rectY+rectSizeY*4+10);
  text("WET", rectX-rectSizeX*2.4+4, rectY+rectSizeY*6+10);
  text("UNKNOWN", rectX-rectSizeX*2.4+4, rectY+rectSizeY*8+10);

  text("DARKNESS", rectX-rectSizeX*1.2+4, rectY+10);
  text("DAYLIGHT", rectX-rectSizeX*1.2+4, rectY+rectSizeY*2+10);
  text("DAWN", rectX-rectSizeX*1.2+4, rectY+rectSizeY*4+10);
  text("DUSK", rectX-rectSizeX*1.2+4, rectY+rectSizeY*6+10);
  text("UNKNOWN", rectX-rectSizeX*1.2+4, rectY+rectSizeY*8+10);
  
  text("CLEAR", rectX+4, rectY+10);
  text("HAZE/FOG", rectX+4, rectY+rectSizeY*2+10);
  text("WIND", rectX+4, rectY+rectSizeY*4+10);
  text("RAIN", rectX+4, rectY+rectSizeY*6+10);
  text("SLEET", rectX+4, rectY+rectSizeY*8+10);
  text("SNOW", rectX+4, rectY+rectSizeY*10+10);
  text("UNKNOWN", rectX+4, rectY+rectSizeY*12+10);
  
popStyle();

}

void update(float x, float y) {
 if ( overRect(rectX, rectY, rectSizeX, rectSizeY) ) {
    rectClearOver = true;
 
  } else {
   rectClearOver = false;
  }
  
  if ( overRect(rectX, rectY+rectSizeY*2, rectSizeX, rectSizeY) ) {
    rectHazeOver = true;
 
  } else {
   rectHazeOver = false;
  }
  
  if ( overRect(rectX, rectY+rectSizeY*4, rectSizeX, rectSizeY) ) {
    rectWindOver = true;
 
  } else {
   rectWindOver = false;
  }
  
  if ( overRect(rectX, rectY+rectSizeY*6, rectSizeX, rectSizeY) ) {
    rectRainOver = true;
 
  } else {
   rectRainOver = false;
  }
  
  if ( overRect(rectX, rectY+rectSizeY*8, rectSizeX, rectSizeY) ) {
    rectSleetOver = true;
 
  } else {
   rectSleetOver = false;
  }
  
  
  
 if ( overRect(rectX, rectY+rectSizeY*10, rectSizeX, rectSizeY) ) {
    rectSnowOver = true;
 
  } else {
   rectSnowOver = false;
  }
  
  
  if ( overRect(rectX, rectY+rectSizeY*12, rectSizeX, rectSizeY) ) {
    rectUnknownWOver = true;
 
  } else {
   rectUnknownWOver = false;
  }
  
  
  if ( overRect(rectX-rectSizeX*1.2, rectY, rectSizeX, rectSizeY) ) {
    rectDarkOver = true;
 
  } else {
   rectDarkOver = false;
  }
  
  if ( overRect(rectX-rectSizeX*1.2, rectY+rectSizeY*2, rectSizeX, rectSizeY) ) {
    rectDayOver = true;
 
  } else {
   rectDayOver = false;
  }
  
  if ( overRect(rectX-rectSizeX*1.2, rectY+rectSizeY*4, rectSizeX, rectSizeY) ) {
    rectDawnOver = true;
 
  } else {
   rectDawnOver = false;
  }
  
  if ( overRect(rectX-rectSizeX*1.2, rectY+rectSizeY*6, rectSizeX, rectSizeY) ) {
    rectDuskOver = true;
 
  } else {
   rectDuskOver = false;
  }
  
  if ( overRect(rectX-rectSizeX*1.2, rectY+rectSizeY*8, rectSizeX, rectSizeY) ) {
    rectUnknownLOver = true;
 
  } else {
   rectUnknownLOver = false;
  }
  
  
  
  if ( overRect(rectX-rectSizeX*2.4, rectY, rectSizeX, rectSizeY) ) {
    rectDryOver = true;
 
  } else {
   rectDryOver = false;
  }
  
   if ( overRect(rectX-rectSizeX*2.4, rectY+rectSizeY*2, rectSizeX, rectSizeY) ) {
    rectIcyOver = true;
 
  } else {
   rectIcyOver = false;
  }
  
   if ( overRect(rectX-rectSizeX*2.4, rectY+rectSizeY*4, rectSizeX, rectSizeY) ) {
    rectSnowyOver = true;
 
  } else {
   rectSnowyOver = false;
  }
  
   if ( overRect(rectX-rectSizeX*2.4, rectY+rectSizeY*6, rectSizeX, rectSizeY) ) {
    rectWetOver = true;
 
  } else {
   rectWetOver = false;
  }
  
   if ( overRect(rectX-rectSizeX*2.4, rectY+rectSizeY*8, rectSizeX, rectSizeY) ) {
    rectUnknownSOver = true;
 
  } else {
   rectUnknownSOver = false;
  }
  
  
}
void mousePressed() {

  crashes = loadTable("crashes.csv", "header");
  float totalCrashes;
  totalCrashes = 4929;
  float crashPercent;
  int crashAmount;
  crashAmount = 0; 
 
  if (rectClearOver) {
    crashAmount = crashes.getInt(0,1);
  }
  
   if (rectHazeOver) {
     crashAmount = crashes.getInt(1,1);
  }
  if (rectWindOver) {
    crashAmount = crashes.getInt(2,1);
  }
  if (rectRainOver) {
    crashAmount = crashes.getInt(3,1);
  }
  if (rectSleetOver) {
    crashAmount = crashes.getInt(4,1);
  }
  if (rectSnowOver) {
    crashAmount = crashes.getInt(5,1);
  }
  if (rectUnknownWOver) {
    crashAmount = crashes.getInt(6,1);
  }
  if (rectDarkOver) {
    crashAmount = crashes.getInt(7,1);
  }
  if (rectDayOver) {
    crashAmount = crashes.getInt(8,1);
  }
  if (rectDawnOver) {
    crashAmount = crashes.getInt(9,1);
  }
  if (rectDuskOver) {
    crashAmount = crashes.getInt(10,1);
  }
  if (rectUnknownLOver) {
    crashAmount = crashes.getInt(11,1);
  }
  if (rectDryOver) {
    crashAmount = crashes.getInt(12,1);
  }
  if (rectIcyOver) {
    crashAmount = crashes.getInt(13,1);
  }
  if (rectSnowyOver) {
    crashAmount = crashes.getInt(14,1);
  }
  if (rectWetOver) {
    crashAmount = crashes.getInt(15,1);
  }
  if (rectUnknownSOver) {
    crashAmount = crashes.getInt(16,1);
  }
    

     crashPercent = crashAmount/totalCrashes;
    circleSize = (sqrt((area*crashPercent)/3.14))*2;

 
  
  
  
}




boolean overRect(float x, float y, float width, float height)  {
  if (mouseX >= x && mouseX <= x+width && 
      mouseY >= y && mouseY <= y+height) {
    return true;
  } else {
    return false;
  }
}

boolean overCircle(float x, float y, float diameter) {
  float disX = x - mouseX;
  float disY = y - mouseY;
  if (sqrt(sq(disX) + sq(disY)) < diameter/2 ) {
    return true;
  } else {
    return false;
  }
}

